#ifndef _I7SIO_H_
#define _I7SIO_H_

#include"I7sPciBase.h"

#ifdef __cplusplus
extern "C" {
#endif  /* __cplusplus */

#ifdef I7SIO_EXPORTS
#define IB7_API __declspec(dllexport)
#else
#define IB7_API __declspec(dllimport)
#endif

IB7_API int WINAPI I7fOpen( int Ib7No );
IB7_API int WINAPI I7fClose( int Ib7No );
IB7_API int WINAPI I7fReset( int Ib7No );
IB7_API int WINAPI I7fGetInfo( PIB7_PARAINFO Ib7ParaInfo );

IB7_API int WINAPI I7fAdRead( PIB7_PARAAD Ib7ParaAd );
IB7_API int WINAPI I7fDaWrite( PIB7_PARADA Ib7ParaDa );

IB7_API int WINAPI I7fEncMode( PIB7_PARAENC Ib7ParaEnc );
IB7_API int WINAPI I7fEncStart( PIB7_PARAENC Ib7ParaEnc );
IB7_API int WINAPI I7fEncRead( PIB7_PARAENC Ib7ParaEnc );
IB7_API int WINAPI I7fEncWrite( PIB7_PARAENC Ib7ParaEnc );
IB7_API int WINAPI I7fEncStop( PIB7_PARAENC Ib7ParaEnc );
IB7_API int WINAPI I7fEncClear( PIB7_PARAENC Ib7ParaEnc );

IB7_API int WINAPI I7fPioWrite( PIB7_PARAPIO Ib7ParaPio );
IB7_API int WINAPI I7fPioRead( PIB7_PARAPIO Ib7ParaPio );
IB7_API int WINAPI I7fPioSet( PIB7_PARAPIO Ib7ParaPio );
IB7_API int WINAPI I7fPioReset( PIB7_PARAPIO Ib7ParaPio );

#ifdef __cplusplus
}
#endif

#endif //_I7SIO_H_